<!doctype html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1, minimum-scale=1" />
<meta name="generator" content="pdoc 0.8.1" />
<title>src.graph_sampling API documentation</title>
<meta name="description" content="This module contains methods to create graph samples of a Neo4j
graph database and some functionality to add attributes for Gephi plots." />
<link href='https://cdnjs.cloudflare.com/ajax/libs/normalize/8.0.0/normalize.min.css' rel='stylesheet'>
<link href='https://cdnjs.cloudflare.com/ajax/libs/10up-sanitize.css/8.0.0/sanitize.min.css' rel='stylesheet'>
<link href="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/styles/github.min.css" rel="stylesheet">
<style>.flex{display:flex !important}body{line-height:1.5em}#content{padding:20px}#sidebar{padding:30px;overflow:hidden}#sidebar > *:last-child{margin-bottom:2cm}.http-server-breadcrumbs{font-size:130%;margin:0 0 15px 0}#footer{font-size:.75em;padding:5px 30px;border-top:1px solid #ddd;text-align:right}#footer p{margin:0 0 0 1em;display:inline-block}#footer p:last-child{margin-right:30px}h1,h2,h3,h4,h5{font-weight:300}h1{font-size:2.5em;line-height:1.1em}h2{font-size:1.75em;margin:1em 0 .50em 0}h3{font-size:1.4em;margin:25px 0 10px 0}h4{margin:0;font-size:105%}a{color:#058;text-decoration:none;transition:color .3s ease-in-out}a:hover{color:#e82}.title code{font-weight:bold}h2[id^="header-"]{margin-top:2em}.ident{color:#900}pre code{background:#f8f8f8;font-size:.8em;line-height:1.4em}code{background:#f2f2f1;padding:1px 4px;overflow-wrap:break-word}h1 code{background:transparent}pre{background:#f8f8f8;border:0;border-top:1px solid #ccc;border-bottom:1px solid #ccc;margin:1em 0;padding:1ex}#http-server-module-list{display:flex;flex-flow:column}#http-server-module-list div{display:flex}#http-server-module-list dt{min-width:10%}#http-server-module-list p{margin-top:0}.toc ul,#index{list-style-type:none;margin:0;padding:0}#index code{background:transparent}#index h3{border-bottom:1px solid #ddd}#index ul{padding:0}#index h4{margin-top:.6em;font-weight:bold}@media (min-width:200ex){#index .two-column{column-count:2}}@media (min-width:300ex){#index .two-column{column-count:3}}dl{margin-bottom:2em}dl dl:last-child{margin-bottom:4em}dd{margin:0 0 1em 3em}#header-classes + dl > dd{margin-bottom:3em}dd dd{margin-left:2em}dd p{margin:10px 0}.name{background:#eee;font-weight:bold;font-size:.85em;padding:5px 10px;display:inline-block;min-width:40%}.name:hover{background:#e0e0e0}.name > span:first-child{white-space:nowrap}.name.class > span:nth-child(2){margin-left:.4em}.inherited{color:#999;border-left:5px solid #eee;padding-left:1em}.inheritance em{font-style:normal;font-weight:bold}.desc h2{font-weight:400;font-size:1.25em}.desc h3{font-size:1em}.desc dt code{background:inherit}.source summary,.git-link-div{color:#666;text-align:right;font-weight:400;font-size:.8em;text-transform:uppercase}.source summary > *{white-space:nowrap;cursor:pointer}.git-link{color:inherit;margin-left:1em}.source pre{max-height:500px;overflow:auto;margin:0}.source pre code{font-size:12px;overflow:visible}.hlist{list-style:none}.hlist li{display:inline}.hlist li:after{content:',\2002'}.hlist li:last-child:after{content:none}.hlist .hlist{display:inline;padding-left:1em}img{max-width:100%}.admonition{padding:.1em .5em;margin-bottom:1em}.admonition-title{font-weight:bold}.admonition.note,.admonition.info,.admonition.important{background:#aef}.admonition.todo,.admonition.versionadded,.admonition.tip,.admonition.hint{background:#dfd}.admonition.warning,.admonition.versionchanged,.admonition.deprecated{background:#fd4}.admonition.error,.admonition.danger,.admonition.caution{background:lightpink}</style>
<style media="screen and (min-width: 700px)">@media screen and (min-width:700px){#sidebar{width:30%;height:100vh;overflow:auto;position:sticky;top:0}#content{width:70%;max-width:100ch;padding:3em 4em;border-left:1px solid #ddd}pre code{font-size:1em}.item .name{font-size:1em}main{display:flex;flex-direction:row-reverse;justify-content:flex-end}.toc ul ul,#index ul{padding-left:1.5em}.toc > ul > li{margin-top:.5em}}</style>
<style media="print">@media print{#sidebar h1{page-break-before:always}.source{display:none}}@media print{*{background:transparent !important;color:#000 !important;box-shadow:none !important;text-shadow:none !important}a[href]:after{content:" (" attr(href) ")";font-size:90%}a[href][title]:after{content:none}abbr[title]:after{content:" (" attr(title) ")"}.ir a:after,a[href^="javascript:"]:after,a[href^="#"]:after{content:""}pre,blockquote{border:1px solid #999;page-break-inside:avoid}thead{display:table-header-group}tr,img{page-break-inside:avoid}img{max-width:100% !important}@page{margin:0.5cm}p,h2,h3{orphans:3;widows:3}h1,h2,h3,h4,h5,h6{page-break-after:avoid}}</style>
</head>
<body>
<main>
<article id="content">
<header>
<h1 class="title">Module <code>src.graph_sampling</code></h1>
</header>
<section id="section-intro">
<p>This module contains methods to create graph samples of a Neo4j
graph database and some functionality to add attributes for Gephi plots.</p>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">&#34;&#34;&#34;This module contains methods to create graph samples of a Neo4j
graph database and some functionality to add attributes for Gephi plots.
&#34;&#34;&#34;

from src.gdb_utils import connect_to_database, run_query
import src.file_management as file_management

import networkx as nx # python graph object
import random # for random node and edge selection
import numpy as np

# Color attributes for Gephi in correspondence to node labels:
METADATA_COLOR = {&#39;r&#39;: 242, &#39;g&#39;: 223, &#39;b&#39;: 182, &#39;a&#39;: 1} # beige
URL_COLOR = {&#39;r&#39;: 141, &#39;g&#39;: 204, &#39;b&#39;: 147, &#39;a&#39;: 1} # green (from Neo4j, inner node color)
HANDLE_COLOR = {&#39;r&#39;: 241, &#39;g&#39;: 102, &#39;b&#39;: 103, &#39;a&#39;: 1} # red (from Neo4j, inner node color)
#URL_COLOR = {&#39;r&#39;: 93, &#39;g&#39;: 182, &#39;b&#39;: 101, &#39;a&#39;: 1} # green (from Neo4j, node border color)
#HANDLE_COLOR = {&#39;r&#39;: 235, &#39;g&#39;: 39, &#39;b&#39;: 40, &#39;a&#39;: 1} # red (from Neo4j, node border color)
#METADATA_COLOR = {&#39;r&#39;: 255, &#39;g&#39;: 128, &#39;b&#39;: 0, &#39;a&#39;: 1} # orange
#URL_COLOR = {&#39;r&#39;: 0, &#39;g&#39;: 204, &#39;b&#39;: 80, &#39;a&#39;: 1} # green
#HANDLE_COLOR = {&#39;r&#39;: 120, &#39;g&#39;: 0, &#39;b&#39;: 220, &#39;a&#39;: 1} # purple


def create_random_node_selection_sample(n:int, session, suppress_output=False):
    &#34;&#34;&#34;Creates a graph sample by using the random
    node selection sampling method.

    Parameters
    ----------
    n: int
        The desired sample size. This is the number of nodes in the sample.
    session: neo4j.Session (https://neo4j.com/docs/api/python-driver/current/api.html#session)
        The session object of the started session for querying the database
    suppress_output: bool
        if true running the queries will create no console output.

    Returns
    -------
    nx.Graph
        A random sample with size &#39;n&#39;, created by using
        random node selection sampling.
    &#34;&#34;&#34;

    rand_p = 3.0* n/12000000 #probability to select a node in random node preselection
    # (there are about 12 million nodes in database, and factor 3.0 as safety to be sure to have enough nodes)

    query_random_nodes = &#34;&#34;&#34;MATCH (n) WHERE rand()&lt;{}
                            RETURN id(n) as id, labels(n) as labels ORDER BY rand() ASC LIMIT {}
                            &#34;&#34;&#34;.format(rand_p, n)
    result_random_nodes = run_query(session, query_random_nodes, suppress_output=suppress_output)
    sample_nodes = [result_random_nodes[&#39;id&#39;][i] for i in range(len(result_random_nodes[&#39;id&#39;]))]

    # Construct induced subgraph: (Between which nodes in the sample exist edges?)
    query_edges = &#34;&#34;&#34;MATCH (n1)-[r]-&gt;(n2) WHERE id(n1) in {} and id(n2) in {}
                            RETURN id(n1) as start, id(n2) as end&#34;&#34;&#34;.format(sample_nodes, sample_nodes)
    result_edges = run_query(session, query_edges, suppress_output=suppress_output)

    # Build networkx graph object from the query result:
    sample_graph = build_nxgraph_random_node(n, result_random_nodes, result_edges)

    return sample_graph


def build_nxgraph_random_node(n, result_random_nodes, result_edges):
    &#34;&#34;&#34; Builds and returns networkx graph from the result of the
    random node selection queries.

    The DUMMY label is being filtered out.

    Parameters
    ----------
    n: int
        The desired sample size. This is the number of nodes in the sample.
    result_random_nodes:
        result from the query &#34;query_random_nodes&#34;
    result_edges:
        result from the query &#34;query_edges&#34;

    Returns
    -------
    nx.Graph
        The networkx Graph that contains the nodes and edges from
        the query results without the DUMMY labels.
    &#34;&#34;&#34;

    sample_edges = [[result_edges[&#39;start&#39;][i],result_edges[&#39;end&#39;][i]] for i in range(len(result_edges[&#39;start&#39;]))]
    sample_random_node = nx.Graph()

    for i in range(n):

        #Determine label and filtering DUMMY label out:
        if &#39;DUMMY&#39; in result_random_nodes[&#39;labels&#39;][i]:
            result_random_nodes[&#39;labels&#39;][i].remove(&#39;DUMMY&#39;)
        node_label = result_random_nodes[&#39;labels&#39;][i][0]

        sample_random_node.add_node(result_random_nodes[&#39;id&#39;][i], label=node_label)

    for edge in sample_edges:
        sample_random_node.add_edge(edge[0],edge[1])

    return sample_random_node


def create_random_walk_sample(sample_size:int, session, c=0.15, suppress_output=False):
    &#34;&#34;&#34;Returns a random walk sample of the graph database.

    Performs a random walk on the graph from the database
    and puts all visited nodes and edges in

    We use our own algorithm to have control of the exact parameters.
    The algortihm&#39;s outline is the following:

    # Goal: Sample graph with m nodes using a random walk algorithm.

    # Idea of Algorithm:
    # 1: Choose starting node s uniformly at random and add it to sample graph S
    # 2: v &lt;- s
    # 3: if rand()&lt;0.15 (=c): jump back to start node s (step 2)
    # 4: (v,w) = e &lt;- choose one neighbor w of v at random  # -- Note: we will need to perform one cypher query for each realization of this step
    # 5: Add e and w to the sample graph S.
    # 6: v &lt;- w
    # 7: Jump back to step 3 if sample graph still has &lt; m nodes

    # keep track of number of visited nodes -&gt; if this number is too small over a long time,
    # s might be part of a small isolated component. In that case start again with another start node s&#39;


    Parameters
    ----------
    sample_size: int
        the number of nodes that should be contained in the
        random walk sample.
    session: neo4j.Session (https://neo4j.com/docs/api/python-driver/current/api.html#session)
        The session object of the started session for querying the database
    c: int
        probability for each step to jump back to the start node.
        The default value 0.15 is the one suggested in

        Jure Leskovec and Christos Faloutsos.
        “Sampling from large graphs”.
        Proceedings of the ACM SIGKDD International Conference on
        Knowledge Discovery and Data Mining 2006 (Jan. 2006),
        pp. 631–636
    suppress_output: bool
        if true running the queries will create no console output

    Returns
    -------
    nx.Graph
        A random sample with size &#39;n&#39;, created by using
        random walk sampling.
    &#34;&#34;&#34;

    # 0 ----------------------------------------------------
    # - Prepare parameters and variables -

    k = 0 # counter of performed steps of the random walk
    restart_limit = sample_size*100    # If after this number of steps the sample graph does not contain m nodes,
                            # the algorithm should be restarted again with different start node
                            # (might have happened that start node was in small isolated community)


    v = 0 # current node in each step of algorithm from which we continue our random walk
    creation_finished = False # flag indicating if sample of required size has been successfully created




    while not creation_finished : # if creation was stopped because not enough nodes were found, restart form here

        sample = nx.Graph() # resulting sample, will be filled with nodes represetned by their ids
        step_count = 0 # counts numbers of steps taken during walk (number of taken edges)

        # 1 ----------------------------------------------------
        # - Select random start node -

        # note: first construct small subset of nodes with cypher and then use python&#39;s random
        # module to select 1 node from that random subset.
        # Using &#34;LIMIT 1&#34; would yield directly one random node. This would however not be a uniformly at random chosen
        # node, as nodes with smaller ids would be favored as they are higher in the returned list of the query

        query_random_subset_ids = &#34;&#34;&#34;MATCH (n) where rand()&lt;0.000001 return id(n) as id&#34;&#34;&#34;
        result_random_subset_ids = run_query(session, query_random_subset_ids, suppress_output=suppress_output)
        random_ids = result_random_subset_ids[&#39;id&#39;]

        #now select 1 random element from this subset:
        random_index = random.randrange(0, len(random_ids))
        start = random_ids.pop(random_index)

        sample.add_node(start)
        sample.nodes[start][&#39;label&#39;] = query_label(start, session)
        print(&#34;Start node {} selected. Executing random walk sampling ...&#34;.format(start))

        # 2 ----------------------------------------------------
        # - Initialize the current node to be the start node -

        while sample.number_of_nodes() &lt; sample_size and step_count &lt; restart_limit:

            v = start

            # 3 ----------------------------------------------------
            # - Jump back to start node with probability (1-c) -

            while random.uniform(0, 1) &gt;= c and sample.number_of_nodes() &lt; sample_size:

                print(&#34;Progress: Current sample contains {} nodes.&#34;.format(sample.number_of_nodes()))
                # 4 ----------------------------------------------------
                # - Select random neighbor of current node -

                query_random_neighbor = &#34;&#34;&#34;MATCH (n)-[]-(m)  WHERE id(n) = {}
                                        WITH collect(id(m)) as Neighbors, size(collect(id(m))) as neighborCount
                                        RETURN Neighbors[toInteger(round( rand()*(neighborCount-1) ))] as id&#34;&#34;&#34;.format(v)
                result_random_neighbor = run_query(session, query_random_neighbor, suppress_output=suppress_output)
                w = result_random_neighbor[&#39;id&#39;][0]
                #Additionally query node label of found neighbor:
                #w_label = query_label(w, session)

                # 5 ----------------------------------------------------
                # - Add new edge to python graph -

                sample.add_edge(v,w)
                #sample.nodes[w][&#39;label&#39;] = w_label

                # 6 ----------------------------------------------------
                # - Update current node -

                v = w
                step_count += 1


        if sample.number_of_nodes() &gt;= sample_size:
            creation_finished = True
            print(&#34;Sample of size &#34;, sample_size, &#34;successfully created.&#34;)
            print(&#34;Step count: &#34;,step_count)

    return sample



def query_label(node_id:int, session):
    &#34;&#34;&#34; Returns the label of the node with id &#39;node_id&#39; from database.

    Parameters
    ----------
    node_id: int
        id of a node in the database
    session: neo4j.Session (https://neo4j.com/docs/api/python-driver/current/api.html#session)
        The session object of the started session for querying the database


    Returns
    -------
    str
        the label of the node with id &#39;node_id&#39;.
        The &#39;DUMMY&#39; label will be filtered out such that only exactly one label will be returned.


    &#34;&#34;&#34;

    query_labels = &#34;&#34;&#34;MATCH (n) WHERE id(n)={} return labels(n) as label&#34;&#34;&#34;.format(node_id)
    result_labels = run_query(session, query_labels, suppress_output=True)
    #filter DUMMY label out:
    if &#39;DUMMY&#39; in result_labels[&#39;label&#39;][0]:
        result_labels[&#39;label&#39;][0].remove(&#39;DUMMY&#39;)
    label = result_labels[&#39;label&#39;][0][0]

    return label


def query_name(node_id:int, session):
    &#34;&#34;&#34; Returns the name of the node with id &#39;node_id&#39; from database.

    By name we mean the attribute &#34;nodeId&#34; in our database. It usually
    has the form [labelname][node content], e.g.
    &#34;creatorPID Service tgpid-service-3.7.0-SNAPSHOT.201503231204&#34;
    for a node with label &#34;creator&#34; and node content
    &#34;PID Service tgpid-service-3.7.0-SNAPSHOT.201503231204&#34;
    (the content is stored in the attribute &#34;creator&#34;)

    Parameters
    ----------
    node_id: int
        id of a node in the database
    session: neo4j.Session (https://neo4j.com/docs/api/python-driver/current/api.html#session)
        The session object of the started session for querying the database


    Returns
    -------
    str
        the name (nodeId attribtute) of the node in the database
        with id &#39;node_id&#39;.


    &#34;&#34;&#34;

    query_name = &#34;&#34;&#34;MATCH (n) WHERE id(n)={} return n.nodeId as name&#34;&#34;&#34;.format(node_id)
    result_name = run_query(session, query_name, suppress_output=True)
    name = result_name[&#39;name&#39;][0]

    return name


def add_label_attributes(sample, session):
    &#34;&#34;&#34;Add label attributes for Gephi plot.

    By label we mean the node label from the Neo4j database. The name of
    the latter label attribute will be &#39;neo_label&#39;, such that it does not
    interfere with the &#39;label&#39; attribute of the networkx that is the
    what is being displayed in gephi as the node name.

    Parameters
    ----------
    sample: nx.Graph
        A graph sample to which we want to set the &#39;viz&#39; attribute to the
        predefined color values in correspondence with the neo4j labels.
    session: neo4j.Session (https://neo4j.com/docs/api/python-driver/current/api.html#session)
        The session object of the started session for querying the database

    Returns
    -------
    nx.Graph
        The same graph with &#39;neo_label&#39; attribute for all nodes.
    &#34;&#34;&#34;
    for v in sample.nodes():

        v_label = query_label(v, session)
        sample.nodes[v][&#39;neo_label&#39;] = v_label

    return sample



def add_color_attributes(sample):
    &#34;&#34;&#34;Add color attributes for Gephi plot.


    Parameters
    ----------
    sample: nx.Graph
        A graph sample to which we want to set the &#39;viz&#39; attribute to the
        predefined color values in correspondence with the labels from neo4j
        which are stored in the this graph in the node attribute &#39;neo_4j&#39;.

    Returns
    -------
    nx.Graph
        The same graph with &#39;viz&#39; attribute for all nodes.
    &#34;&#34;&#34;
    for v in sample.nodes():
        if not &#39;neo_label&#39; in sample.nodes[v]:
            return sample
        if sample.nodes[v][&#39;neo_label&#39;] == &#39;handle&#39;:
            sample.nodes[v][&#39;viz&#39;] = {&#39;color&#39;: HANDLE_COLOR}
        elif sample.nodes[v][&#39;neo_label&#39;] == &#39;url&#39;:
            sample.nodes[v][&#39;viz&#39;] = {&#39;color&#39;: URL_COLOR}
        else:
            sample.nodes[v][&#39;viz&#39;] = {&#39;color&#39;: METADATA_COLOR}
    return sample



def add_name_attributes(sample, session):
    &#34;&#34;&#34;Add name attributes for Gephi plot.

    By name we mean the attribute &#34;nodeId&#34; in our database. It usually
    has the form [labelname][node content], e.g.
    &#34;creatorPID Service tgpid-service-3.7.0-SNAPSHOT.201503231204&#34;
    for a node with label &#34;creator&#34; and node content
    &#34;PID Service tgpid-service-3.7.0-SNAPSHOT.201503231204&#34;
    (the content is stored in the attribute &#34;creator&#34;)

    However, we only add this for metadata nodes, as the names of
    handles and URL are just long and not interesting for the plot.

    Parameters
    ----------
    sample: nx.Graph
        A graph sample to which we want to set the &#39;viz&#39; attribute to the
        predefined color values in correspondence with the labels.
    session: neo4j.Session (https://neo4j.com/docs/api/python-driver/current/api.html#session)
        The session object of the started session for querying the database
    Returns
    -------
    nx.Graph
        The same graph with new &#39;label&#39; attribute for all nodes containing
        the names (attribtue &#34;nodeId&#34; in Neo4j).
        The former &#39;label&#39; attributes are moved to attribute &#39;neo_label&#39;.
    &#34;&#34;&#34;
    for v in sample.nodes():

        if &#39;neo_label&#39; in sample.nodes[v]: # data must be labelled!

            # only add name for metadata nodes under &#39;label&#39;: (handles and URLs keep label &#34;handle&#34;/&#34;url&#34;)
            if (not sample.nodes[v][&#39;neo_label&#39;] == &#39;handle&#39;) and (not sample.nodes[v][&#39;neo_label&#39;] == &#39;url&#39;):
                sample.nodes[v][&#39;label&#39;] = query_name(v, session)
            else:
                sample.nodes[v][&#39;label&#39;] = &#34;&#34;
        else:
            print(&#34;graph is not labelled. Please call method add_label_attributes on this graph first.&#34;)
            return sample
    return sample

def add_gephi_attributes(sample, session):
    &#34;&#34;&#34;Makes sample ready to be Gephi-plottable.

    In particular, it adds to the nodes attributes holding
    the node label names from the Neo4j database, the colors
    in accordance with these node labels and the names of the
    metadata nodes.

    Parameters
    ----------
    sample: nx.Graph
        a graph sample
    session: neo4j.Session (https://neo4j.com/docs/api/python-driver/current/api.html#session)
        The session object of the started session for querying the database
    Returns
    -------
    nx.Graph
        The provided graph sample with added node attributes.
    &#34;&#34;&#34;

    sample = add_label_attributes(sample, session)
    sample = add_color_attributes(sample)
    sample = add_name_attributes(sample, session)

    return sample</code></pre>
</details>
</section>
<section>
</section>
<section>
</section>
<section>
<h2 class="section-title" id="header-functions">Functions</h2>
<dl>
<dt id="src.graph_sampling.add_color_attributes"><code class="name flex">
<span>def <span class="ident">add_color_attributes</span></span>(<span>sample)</span>
</code></dt>
<dd>
<div class="desc"><p>Add color attributes for Gephi plot.</p>
<h2 id="parameters">Parameters</h2>
<dl>
<dt><strong><code>sample</code></strong> :&ensp;<code>nx.Graph</code></dt>
<dd>A graph sample to which we want to set the 'viz' attribute to the
predefined color values in correspondence with the labels from neo4j
which are stored in the this graph in the node attribute 'neo_4j'.</dd>
</dl>
<h2 id="returns">Returns</h2>
<dl>
<dt><code>nx.Graph</code></dt>
<dd>The same graph with 'viz' attribute for all nodes.</dd>
</dl></div>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def add_color_attributes(sample):
    &#34;&#34;&#34;Add color attributes for Gephi plot.


    Parameters
    ----------
    sample: nx.Graph
        A graph sample to which we want to set the &#39;viz&#39; attribute to the
        predefined color values in correspondence with the labels from neo4j
        which are stored in the this graph in the node attribute &#39;neo_4j&#39;.

    Returns
    -------
    nx.Graph
        The same graph with &#39;viz&#39; attribute for all nodes.
    &#34;&#34;&#34;
    for v in sample.nodes():
        if not &#39;neo_label&#39; in sample.nodes[v]:
            return sample
        if sample.nodes[v][&#39;neo_label&#39;] == &#39;handle&#39;:
            sample.nodes[v][&#39;viz&#39;] = {&#39;color&#39;: HANDLE_COLOR}
        elif sample.nodes[v][&#39;neo_label&#39;] == &#39;url&#39;:
            sample.nodes[v][&#39;viz&#39;] = {&#39;color&#39;: URL_COLOR}
        else:
            sample.nodes[v][&#39;viz&#39;] = {&#39;color&#39;: METADATA_COLOR}
    return sample</code></pre>
</details>
</dd>
<dt id="src.graph_sampling.add_gephi_attributes"><code class="name flex">
<span>def <span class="ident">add_gephi_attributes</span></span>(<span>sample, session)</span>
</code></dt>
<dd>
<div class="desc"><p>Makes sample ready to be Gephi-plottable.</p>
<p>In particular, it adds to the nodes attributes holding
the node label names from the Neo4j database, the colors
in accordance with these node labels and the names of the
metadata nodes.</p>
<h2 id="parameters">Parameters</h2>
<dl>
<dt><strong><code>sample</code></strong> :&ensp;<code>nx.Graph</code></dt>
<dd>a graph sample</dd>
<dt><strong><code>session</code></strong> :&ensp;<code>neo4j.Session (&lt;https://neo4j.com/docs/api/python-driver/current/api.html#session&gt;)</code></dt>
<dd>The session object of the started session for querying the database</dd>
</dl>
<h2 id="returns">Returns</h2>
<dl>
<dt><code>nx.Graph</code></dt>
<dd>The provided graph sample with added node attributes.</dd>
</dl></div>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def add_gephi_attributes(sample, session):
    &#34;&#34;&#34;Makes sample ready to be Gephi-plottable.

    In particular, it adds to the nodes attributes holding
    the node label names from the Neo4j database, the colors
    in accordance with these node labels and the names of the
    metadata nodes.

    Parameters
    ----------
    sample: nx.Graph
        a graph sample
    session: neo4j.Session (https://neo4j.com/docs/api/python-driver/current/api.html#session)
        The session object of the started session for querying the database
    Returns
    -------
    nx.Graph
        The provided graph sample with added node attributes.
    &#34;&#34;&#34;

    sample = add_label_attributes(sample, session)
    sample = add_color_attributes(sample)
    sample = add_name_attributes(sample, session)

    return sample</code></pre>
</details>
</dd>
<dt id="src.graph_sampling.add_label_attributes"><code class="name flex">
<span>def <span class="ident">add_label_attributes</span></span>(<span>sample, session)</span>
</code></dt>
<dd>
<div class="desc"><p>Add label attributes for Gephi plot.</p>
<p>By label we mean the node label from the Neo4j database. The name of
the latter label attribute will be 'neo_label', such that it does not
interfere with the 'label' attribute of the networkx that is the
what is being displayed in gephi as the node name.</p>
<h2 id="parameters">Parameters</h2>
<dl>
<dt><strong><code>sample</code></strong> :&ensp;<code>nx.Graph</code></dt>
<dd>A graph sample to which we want to set the 'viz' attribute to the
predefined color values in correspondence with the neo4j labels.</dd>
<dt><strong><code>session</code></strong> :&ensp;<code>neo4j.Session (&lt;https://neo4j.com/docs/api/python-driver/current/api.html#session&gt;)</code></dt>
<dd>The session object of the started session for querying the database</dd>
</dl>
<h2 id="returns">Returns</h2>
<dl>
<dt><code>nx.Graph</code></dt>
<dd>The same graph with 'neo_label' attribute for all nodes.</dd>
</dl></div>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def add_label_attributes(sample, session):
    &#34;&#34;&#34;Add label attributes for Gephi plot.

    By label we mean the node label from the Neo4j database. The name of
    the latter label attribute will be &#39;neo_label&#39;, such that it does not
    interfere with the &#39;label&#39; attribute of the networkx that is the
    what is being displayed in gephi as the node name.

    Parameters
    ----------
    sample: nx.Graph
        A graph sample to which we want to set the &#39;viz&#39; attribute to the
        predefined color values in correspondence with the neo4j labels.
    session: neo4j.Session (https://neo4j.com/docs/api/python-driver/current/api.html#session)
        The session object of the started session for querying the database

    Returns
    -------
    nx.Graph
        The same graph with &#39;neo_label&#39; attribute for all nodes.
    &#34;&#34;&#34;
    for v in sample.nodes():

        v_label = query_label(v, session)
        sample.nodes[v][&#39;neo_label&#39;] = v_label

    return sample</code></pre>
</details>
</dd>
<dt id="src.graph_sampling.add_name_attributes"><code class="name flex">
<span>def <span class="ident">add_name_attributes</span></span>(<span>sample, session)</span>
</code></dt>
<dd>
<div class="desc"><p>Add name attributes for Gephi plot.</p>
<p>By name we mean the attribute "nodeId" in our database. It usually
has the form [labelname][node content], e.g.
"creatorPID Service tgpid-service-3.7.0-SNAPSHOT.201503231204"
for a node with label "creator" and node content
"PID Service tgpid-service-3.7.0-SNAPSHOT.201503231204"
(the content is stored in the attribute "creator")</p>
<p>However, we only add this for metadata nodes, as the names of
handles and URL are just long and not interesting for the plot.</p>
<h2 id="parameters">Parameters</h2>
<dl>
<dt><strong><code>sample</code></strong> :&ensp;<code>nx.Graph</code></dt>
<dd>A graph sample to which we want to set the 'viz' attribute to the
predefined color values in correspondence with the labels.</dd>
<dt><strong><code>session</code></strong> :&ensp;<code>neo4j.Session (&lt;https://neo4j.com/docs/api/python-driver/current/api.html#session&gt;)</code></dt>
<dd>The session object of the started session for querying the database</dd>
</dl>
<h2 id="returns">Returns</h2>
<dl>
<dt><code>nx.Graph</code></dt>
<dd>The same graph with new 'label' attribute for all nodes containing
the names (attribtue "nodeId" in Neo4j).
The former 'label' attributes are moved to attribute 'neo_label'.</dd>
</dl></div>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def add_name_attributes(sample, session):
    &#34;&#34;&#34;Add name attributes for Gephi plot.

    By name we mean the attribute &#34;nodeId&#34; in our database. It usually
    has the form [labelname][node content], e.g.
    &#34;creatorPID Service tgpid-service-3.7.0-SNAPSHOT.201503231204&#34;
    for a node with label &#34;creator&#34; and node content
    &#34;PID Service tgpid-service-3.7.0-SNAPSHOT.201503231204&#34;
    (the content is stored in the attribute &#34;creator&#34;)

    However, we only add this for metadata nodes, as the names of
    handles and URL are just long and not interesting for the plot.

    Parameters
    ----------
    sample: nx.Graph
        A graph sample to which we want to set the &#39;viz&#39; attribute to the
        predefined color values in correspondence with the labels.
    session: neo4j.Session (https://neo4j.com/docs/api/python-driver/current/api.html#session)
        The session object of the started session for querying the database
    Returns
    -------
    nx.Graph
        The same graph with new &#39;label&#39; attribute for all nodes containing
        the names (attribtue &#34;nodeId&#34; in Neo4j).
        The former &#39;label&#39; attributes are moved to attribute &#39;neo_label&#39;.
    &#34;&#34;&#34;
    for v in sample.nodes():

        if &#39;neo_label&#39; in sample.nodes[v]: # data must be labelled!

            # only add name for metadata nodes under &#39;label&#39;: (handles and URLs keep label &#34;handle&#34;/&#34;url&#34;)
            if (not sample.nodes[v][&#39;neo_label&#39;] == &#39;handle&#39;) and (not sample.nodes[v][&#39;neo_label&#39;] == &#39;url&#39;):
                sample.nodes[v][&#39;label&#39;] = query_name(v, session)
            else:
                sample.nodes[v][&#39;label&#39;] = &#34;&#34;
        else:
            print(&#34;graph is not labelled. Please call method add_label_attributes on this graph first.&#34;)
            return sample
    return sample</code></pre>
</details>
</dd>
<dt id="src.graph_sampling.build_nxgraph_random_node"><code class="name flex">
<span>def <span class="ident">build_nxgraph_random_node</span></span>(<span>n, result_random_nodes, result_edges)</span>
</code></dt>
<dd>
<div class="desc"><p>Builds and returns networkx graph from the result of the
random node selection queries.</p>
<p>The DUMMY label is being filtered out.</p>
<h2 id="parameters">Parameters</h2>
<dl>
<dt><strong><code>n</code></strong> :&ensp;<code>int</code></dt>
<dd>The desired sample size. This is the number of nodes in the sample.</dd>
</dl>
<p>result_random_nodes:
result from the query "query_random_nodes"
result_edges:
result from the query "query_edges"</p>
<h2 id="returns">Returns</h2>
<dl>
<dt><code>nx.Graph</code></dt>
<dd>The networkx Graph that contains the nodes and edges from
the query results without the DUMMY labels.</dd>
</dl></div>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def build_nxgraph_random_node(n, result_random_nodes, result_edges):
    &#34;&#34;&#34; Builds and returns networkx graph from the result of the
    random node selection queries.

    The DUMMY label is being filtered out.

    Parameters
    ----------
    n: int
        The desired sample size. This is the number of nodes in the sample.
    result_random_nodes:
        result from the query &#34;query_random_nodes&#34;
    result_edges:
        result from the query &#34;query_edges&#34;

    Returns
    -------
    nx.Graph
        The networkx Graph that contains the nodes and edges from
        the query results without the DUMMY labels.
    &#34;&#34;&#34;

    sample_edges = [[result_edges[&#39;start&#39;][i],result_edges[&#39;end&#39;][i]] for i in range(len(result_edges[&#39;start&#39;]))]
    sample_random_node = nx.Graph()

    for i in range(n):

        #Determine label and filtering DUMMY label out:
        if &#39;DUMMY&#39; in result_random_nodes[&#39;labels&#39;][i]:
            result_random_nodes[&#39;labels&#39;][i].remove(&#39;DUMMY&#39;)
        node_label = result_random_nodes[&#39;labels&#39;][i][0]

        sample_random_node.add_node(result_random_nodes[&#39;id&#39;][i], label=node_label)

    for edge in sample_edges:
        sample_random_node.add_edge(edge[0],edge[1])

    return sample_random_node</code></pre>
</details>
</dd>
<dt id="src.graph_sampling.create_random_node_selection_sample"><code class="name flex">
<span>def <span class="ident">create_random_node_selection_sample</span></span>(<span>n: int, session, suppress_output=False)</span>
</code></dt>
<dd>
<div class="desc"><p>Creates a graph sample by using the random
node selection sampling method.</p>
<h2 id="parameters">Parameters</h2>
<dl>
<dt><strong><code>n</code></strong> :&ensp;<code>int</code></dt>
<dd>The desired sample size. This is the number of nodes in the sample.</dd>
<dt><strong><code>session</code></strong> :&ensp;<code>neo4j.Session (&lt;https://neo4j.com/docs/api/python-driver/current/api.html#session&gt;)</code></dt>
<dd>The session object of the started session for querying the database</dd>
<dt><strong><code>suppress_output</code></strong> :&ensp;<code>bool</code></dt>
<dd>if true running the queries will create no console output.</dd>
</dl>
<h2 id="returns">Returns</h2>
<dl>
<dt><code>nx.Graph</code></dt>
<dd>A random sample with size 'n', created by using
random node selection sampling.</dd>
</dl></div>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def create_random_node_selection_sample(n:int, session, suppress_output=False):
    &#34;&#34;&#34;Creates a graph sample by using the random
    node selection sampling method.

    Parameters
    ----------
    n: int
        The desired sample size. This is the number of nodes in the sample.
    session: neo4j.Session (https://neo4j.com/docs/api/python-driver/current/api.html#session)
        The session object of the started session for querying the database
    suppress_output: bool
        if true running the queries will create no console output.

    Returns
    -------
    nx.Graph
        A random sample with size &#39;n&#39;, created by using
        random node selection sampling.
    &#34;&#34;&#34;

    rand_p = 3.0* n/12000000 #probability to select a node in random node preselection
    # (there are about 12 million nodes in database, and factor 3.0 as safety to be sure to have enough nodes)

    query_random_nodes = &#34;&#34;&#34;MATCH (n) WHERE rand()&lt;{}
                            RETURN id(n) as id, labels(n) as labels ORDER BY rand() ASC LIMIT {}
                            &#34;&#34;&#34;.format(rand_p, n)
    result_random_nodes = run_query(session, query_random_nodes, suppress_output=suppress_output)
    sample_nodes = [result_random_nodes[&#39;id&#39;][i] for i in range(len(result_random_nodes[&#39;id&#39;]))]

    # Construct induced subgraph: (Between which nodes in the sample exist edges?)
    query_edges = &#34;&#34;&#34;MATCH (n1)-[r]-&gt;(n2) WHERE id(n1) in {} and id(n2) in {}
                            RETURN id(n1) as start, id(n2) as end&#34;&#34;&#34;.format(sample_nodes, sample_nodes)
    result_edges = run_query(session, query_edges, suppress_output=suppress_output)

    # Build networkx graph object from the query result:
    sample_graph = build_nxgraph_random_node(n, result_random_nodes, result_edges)

    return sample_graph</code></pre>
</details>
</dd>
<dt id="src.graph_sampling.create_random_walk_sample"><code class="name flex">
<span>def <span class="ident">create_random_walk_sample</span></span>(<span>sample_size: int, session, c=0.15, suppress_output=False)</span>
</code></dt>
<dd>
<div class="desc"><p>Returns a random walk sample of the graph database.</p>
<p>Performs a random walk on the graph from the database
and puts all visited nodes and edges in</p>
<p>We use our own algorithm to have control of the exact parameters.
The algortihm's outline is the following:</p>
<h1 id="goal-sample-graph-with-m-nodes-using-a-random-walk-algorithm">Goal: Sample graph with m nodes using a random walk algorithm.</h1>
<h1 id="idea-of-algorithm">Idea of Algorithm:</h1>
<h1 id="1-choose-starting-node-s-uniformly-at-random-and-add-it-to-sample-graph-s">1: Choose starting node s uniformly at random and add it to sample graph S</h1>
<h1 id="2-v-s">2: v &lt;- s</h1>
<h1 id="3-if-rand015-c-jump-back-to-start-node-s-step-2">3: if rand()&lt;0.15 (=c): jump back to start node s (step 2)</h1>
<h1 id="4-vw-e-choose-one-neighbor-w-of-v-at-random-note-we-will-need-to-perform-one-cypher-query-for-each-realization-of-this-step">4: (v,w) = e &lt;- choose one neighbor w of v at random
# &ndash; Note: we will need to perform one cypher query for each realization of this step</h1>
<h1 id="5-add-e-and-w-to-the-sample-graph-s">5: Add e and w to the sample graph S.</h1>
<h1 id="6-v-w">6: v &lt;- w</h1>
<h1 id="7-jump-back-to-step-3-if-sample-graph-still-has-m-nodes">7: Jump back to step 3 if sample graph still has &lt; m nodes</h1>
<h1 id="keep-track-of-number-of-visited-nodes-if-this-number-is-too-small-over-a-long-time">keep track of number of visited nodes -&gt; if this number is too small over a long time,</h1>
<h1 id="s-might-be-part-of-a-small-isolated-component-in-that-case-start-again-with-another-start-node-s">s might be part of a small isolated component. In that case start again with another start node s'</h1>
<h2 id="parameters">Parameters</h2>
<dl>
<dt><strong><code>sample_size</code></strong> :&ensp;<code>int</code></dt>
<dd>the number of nodes that should be contained in the
random walk sample.</dd>
<dt><strong><code>session</code></strong> :&ensp;<code>neo4j.Session (&lt;https://neo4j.com/docs/api/python-driver/current/api.html#session&gt;)</code></dt>
<dd>The session object of the started session for querying the database</dd>
<dt><strong><code>c</code></strong> :&ensp;<code>int</code></dt>
<dd>
<p>probability for each step to jump back to the start node.
The default value 0.15 is the one suggested in</p>
<p>Jure Leskovec and Christos Faloutsos.
“Sampling from large graphs”.
Proceedings of the ACM SIGKDD International Conference on
Knowledge Discovery and Data Mining 2006 (Jan. 2006),
pp. 631–636</p>
</dd>
<dt><strong><code>suppress_output</code></strong> :&ensp;<code>bool</code></dt>
<dd>if true running the queries will create no console output</dd>
</dl>
<h2 id="returns">Returns</h2>
<dl>
<dt><code>nx.Graph</code></dt>
<dd>A random sample with size 'n', created by using
random walk sampling.</dd>
</dl></div>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def create_random_walk_sample(sample_size:int, session, c=0.15, suppress_output=False):
    &#34;&#34;&#34;Returns a random walk sample of the graph database.

    Performs a random walk on the graph from the database
    and puts all visited nodes and edges in

    We use our own algorithm to have control of the exact parameters.
    The algortihm&#39;s outline is the following:

    # Goal: Sample graph with m nodes using a random walk algorithm.

    # Idea of Algorithm:
    # 1: Choose starting node s uniformly at random and add it to sample graph S
    # 2: v &lt;- s
    # 3: if rand()&lt;0.15 (=c): jump back to start node s (step 2)
    # 4: (v,w) = e &lt;- choose one neighbor w of v at random  # -- Note: we will need to perform one cypher query for each realization of this step
    # 5: Add e and w to the sample graph S.
    # 6: v &lt;- w
    # 7: Jump back to step 3 if sample graph still has &lt; m nodes

    # keep track of number of visited nodes -&gt; if this number is too small over a long time,
    # s might be part of a small isolated component. In that case start again with another start node s&#39;


    Parameters
    ----------
    sample_size: int
        the number of nodes that should be contained in the
        random walk sample.
    session: neo4j.Session (https://neo4j.com/docs/api/python-driver/current/api.html#session)
        The session object of the started session for querying the database
    c: int
        probability for each step to jump back to the start node.
        The default value 0.15 is the one suggested in

        Jure Leskovec and Christos Faloutsos.
        “Sampling from large graphs”.
        Proceedings of the ACM SIGKDD International Conference on
        Knowledge Discovery and Data Mining 2006 (Jan. 2006),
        pp. 631–636
    suppress_output: bool
        if true running the queries will create no console output

    Returns
    -------
    nx.Graph
        A random sample with size &#39;n&#39;, created by using
        random walk sampling.
    &#34;&#34;&#34;

    # 0 ----------------------------------------------------
    # - Prepare parameters and variables -

    k = 0 # counter of performed steps of the random walk
    restart_limit = sample_size*100    # If after this number of steps the sample graph does not contain m nodes,
                            # the algorithm should be restarted again with different start node
                            # (might have happened that start node was in small isolated community)


    v = 0 # current node in each step of algorithm from which we continue our random walk
    creation_finished = False # flag indicating if sample of required size has been successfully created




    while not creation_finished : # if creation was stopped because not enough nodes were found, restart form here

        sample = nx.Graph() # resulting sample, will be filled with nodes represetned by their ids
        step_count = 0 # counts numbers of steps taken during walk (number of taken edges)

        # 1 ----------------------------------------------------
        # - Select random start node -

        # note: first construct small subset of nodes with cypher and then use python&#39;s random
        # module to select 1 node from that random subset.
        # Using &#34;LIMIT 1&#34; would yield directly one random node. This would however not be a uniformly at random chosen
        # node, as nodes with smaller ids would be favored as they are higher in the returned list of the query

        query_random_subset_ids = &#34;&#34;&#34;MATCH (n) where rand()&lt;0.000001 return id(n) as id&#34;&#34;&#34;
        result_random_subset_ids = run_query(session, query_random_subset_ids, suppress_output=suppress_output)
        random_ids = result_random_subset_ids[&#39;id&#39;]

        #now select 1 random element from this subset:
        random_index = random.randrange(0, len(random_ids))
        start = random_ids.pop(random_index)

        sample.add_node(start)
        sample.nodes[start][&#39;label&#39;] = query_label(start, session)
        print(&#34;Start node {} selected. Executing random walk sampling ...&#34;.format(start))

        # 2 ----------------------------------------------------
        # - Initialize the current node to be the start node -

        while sample.number_of_nodes() &lt; sample_size and step_count &lt; restart_limit:

            v = start

            # 3 ----------------------------------------------------
            # - Jump back to start node with probability (1-c) -

            while random.uniform(0, 1) &gt;= c and sample.number_of_nodes() &lt; sample_size:

                print(&#34;Progress: Current sample contains {} nodes.&#34;.format(sample.number_of_nodes()))
                # 4 ----------------------------------------------------
                # - Select random neighbor of current node -

                query_random_neighbor = &#34;&#34;&#34;MATCH (n)-[]-(m)  WHERE id(n) = {}
                                        WITH collect(id(m)) as Neighbors, size(collect(id(m))) as neighborCount
                                        RETURN Neighbors[toInteger(round( rand()*(neighborCount-1) ))] as id&#34;&#34;&#34;.format(v)
                result_random_neighbor = run_query(session, query_random_neighbor, suppress_output=suppress_output)
                w = result_random_neighbor[&#39;id&#39;][0]
                #Additionally query node label of found neighbor:
                #w_label = query_label(w, session)

                # 5 ----------------------------------------------------
                # - Add new edge to python graph -

                sample.add_edge(v,w)
                #sample.nodes[w][&#39;label&#39;] = w_label

                # 6 ----------------------------------------------------
                # - Update current node -

                v = w
                step_count += 1


        if sample.number_of_nodes() &gt;= sample_size:
            creation_finished = True
            print(&#34;Sample of size &#34;, sample_size, &#34;successfully created.&#34;)
            print(&#34;Step count: &#34;,step_count)

    return sample</code></pre>
</details>
</dd>
<dt id="src.graph_sampling.query_label"><code class="name flex">
<span>def <span class="ident">query_label</span></span>(<span>node_id: int, session)</span>
</code></dt>
<dd>
<div class="desc"><p>Returns the label of the node with id 'node_id' from database.</p>
<h2 id="parameters">Parameters</h2>
<dl>
<dt><strong><code>node_id</code></strong> :&ensp;<code>int</code></dt>
<dd>id of a node in the database</dd>
<dt><strong><code>session</code></strong> :&ensp;<code>neo4j.Session (&lt;https://neo4j.com/docs/api/python-driver/current/api.html#session&gt;)</code></dt>
<dd>The session object of the started session for querying the database</dd>
</dl>
<h2 id="returns">Returns</h2>
<dl>
<dt><code>str</code></dt>
<dd>the label of the node with id 'node_id'.
The 'DUMMY' label will be filtered out such that only exactly one label will be returned.</dd>
</dl></div>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def query_label(node_id:int, session):
    &#34;&#34;&#34; Returns the label of the node with id &#39;node_id&#39; from database.

    Parameters
    ----------
    node_id: int
        id of a node in the database
    session: neo4j.Session (https://neo4j.com/docs/api/python-driver/current/api.html#session)
        The session object of the started session for querying the database


    Returns
    -------
    str
        the label of the node with id &#39;node_id&#39;.
        The &#39;DUMMY&#39; label will be filtered out such that only exactly one label will be returned.


    &#34;&#34;&#34;

    query_labels = &#34;&#34;&#34;MATCH (n) WHERE id(n)={} return labels(n) as label&#34;&#34;&#34;.format(node_id)
    result_labels = run_query(session, query_labels, suppress_output=True)
    #filter DUMMY label out:
    if &#39;DUMMY&#39; in result_labels[&#39;label&#39;][0]:
        result_labels[&#39;label&#39;][0].remove(&#39;DUMMY&#39;)
    label = result_labels[&#39;label&#39;][0][0]

    return label</code></pre>
</details>
</dd>
<dt id="src.graph_sampling.query_name"><code class="name flex">
<span>def <span class="ident">query_name</span></span>(<span>node_id: int, session)</span>
</code></dt>
<dd>
<div class="desc"><p>Returns the name of the node with id 'node_id' from database.</p>
<p>By name we mean the attribute "nodeId" in our database. It usually
has the form [labelname][node content], e.g.
"creatorPID Service tgpid-service-3.7.0-SNAPSHOT.201503231204"
for a node with label "creator" and node content
"PID Service tgpid-service-3.7.0-SNAPSHOT.201503231204"
(the content is stored in the attribute "creator")</p>
<h2 id="parameters">Parameters</h2>
<dl>
<dt><strong><code>node_id</code></strong> :&ensp;<code>int</code></dt>
<dd>id of a node in the database</dd>
<dt><strong><code>session</code></strong> :&ensp;<code>neo4j.Session (&lt;https://neo4j.com/docs/api/python-driver/current/api.html#session&gt;)</code></dt>
<dd>The session object of the started session for querying the database</dd>
</dl>
<h2 id="returns">Returns</h2>
<dl>
<dt><code>str</code></dt>
<dd>the name (nodeId attribtute) of the node in the database
with id 'node_id'.</dd>
</dl></div>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def query_name(node_id:int, session):
    &#34;&#34;&#34; Returns the name of the node with id &#39;node_id&#39; from database.

    By name we mean the attribute &#34;nodeId&#34; in our database. It usually
    has the form [labelname][node content], e.g.
    &#34;creatorPID Service tgpid-service-3.7.0-SNAPSHOT.201503231204&#34;
    for a node with label &#34;creator&#34; and node content
    &#34;PID Service tgpid-service-3.7.0-SNAPSHOT.201503231204&#34;
    (the content is stored in the attribute &#34;creator&#34;)

    Parameters
    ----------
    node_id: int
        id of a node in the database
    session: neo4j.Session (https://neo4j.com/docs/api/python-driver/current/api.html#session)
        The session object of the started session for querying the database


    Returns
    -------
    str
        the name (nodeId attribtute) of the node in the database
        with id &#39;node_id&#39;.


    &#34;&#34;&#34;

    query_name = &#34;&#34;&#34;MATCH (n) WHERE id(n)={} return n.nodeId as name&#34;&#34;&#34;.format(node_id)
    result_name = run_query(session, query_name, suppress_output=True)
    name = result_name[&#39;name&#39;][0]

    return name</code></pre>
</details>
</dd>
</dl>
</section>
<section>
</section>
</article>
<nav id="sidebar">
<h1>Index</h1>
<div class="toc">
<ul></ul>
</div>
<ul id="index">
<li><h3>Super-module</h3>
<ul>
<li><code><a title="src" href="index.html">src</a></code></li>
</ul>
</li>
<li><h3><a href="#header-functions">Functions</a></h3>
<ul class="">
<li><code><a title="src.graph_sampling.add_color_attributes" href="#src.graph_sampling.add_color_attributes">add_color_attributes</a></code></li>
<li><code><a title="src.graph_sampling.add_gephi_attributes" href="#src.graph_sampling.add_gephi_attributes">add_gephi_attributes</a></code></li>
<li><code><a title="src.graph_sampling.add_label_attributes" href="#src.graph_sampling.add_label_attributes">add_label_attributes</a></code></li>
<li><code><a title="src.graph_sampling.add_name_attributes" href="#src.graph_sampling.add_name_attributes">add_name_attributes</a></code></li>
<li><code><a title="src.graph_sampling.build_nxgraph_random_node" href="#src.graph_sampling.build_nxgraph_random_node">build_nxgraph_random_node</a></code></li>
<li><code><a title="src.graph_sampling.create_random_node_selection_sample" href="#src.graph_sampling.create_random_node_selection_sample">create_random_node_selection_sample</a></code></li>
<li><code><a title="src.graph_sampling.create_random_walk_sample" href="#src.graph_sampling.create_random_walk_sample">create_random_walk_sample</a></code></li>
<li><code><a title="src.graph_sampling.query_label" href="#src.graph_sampling.query_label">query_label</a></code></li>
<li><code><a title="src.graph_sampling.query_name" href="#src.graph_sampling.query_name">query_name</a></code></li>
</ul>
</li>
</ul>
</nav>
</main>
<footer id="footer">
<p>Generated by <a href="https://pdoc3.github.io/pdoc"><cite>pdoc</cite> 0.8.1</a>.</p>
</footer>
<script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/highlight.min.js"></script>
<script>hljs.initHighlightingOnLoad()</script>
</body>
</html>